from socket import socket, AF_INET, SOCK_STREAM,SOL_SOCKET,SO_REUSEADDR
from threading import Thread
import TCPp2p.TCPReceiverHandler


class TCPDefaultHandler(TCPp2p.TCPReceiverHandler.TCPReceiverHandler):

    def Handle(self, ip, port, message):
        pass


class TCPReceiverThread(Thread):

    def __init__(self, port=5555, buffer=1024, handler=TCPDefaultHandler()):
        super(TCPReceiverThread, self).__init__()
        self.stopped = False
        self.port = port
        self.buffer = buffer
        self.socketserver = socket(AF_INET, SOCK_STREAM)
        self.socketserver.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
        self.socketserver.bind(("", self.port))
        self.tcphandlers = {handler}

    def run(self):
        while not self.stopped:
            self.socketserver.listen()
            conn, addr = self.socketserver.accept()
            while 1:
                data = conn.recv(self.buffer)
                if not data:
                    break
                else:
                    for handler in self.tcphandlers:
                        handler.Handle(addr[0], addr[1], data)

        self.socketserver.close()

    def setport(self, port):
        self.port = port

    def setbuffer(self, buffer):
        self.buffer = buffer

    def stop(self):
        self.stopped = True

    def addlistener(self, handler):
        self.tcphandlers.add(handler)
